package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineSymbolGroup struct {
	api.Api
}

// GetPage 获取交易对组列表列表
// @Summary 获取交易对组列表列表
// @Description 获取交易对组列表列表
// @Tags 交易对组列表
// @Param type query string false "类型:1=现货,2=合约"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineSymbolGroup}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-symbol-group [get]
// @Security Bearer
func (e LineSymbolGroup) GetPage(c *gin.Context) {
	req := dto.LineSymbolGroupGetPageReq{}
	s := service.LineSymbolGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineSymbolGroup, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取交易对组列表失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取交易对组列表
// @Summary 获取交易对组列表
// @Description 获取交易对组列表
// @Tags 交易对组列表
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineSymbolGroup} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-symbol-group/{id} [get]
// @Security Bearer
func (e LineSymbolGroup) Get(c *gin.Context) {
	req := dto.LineSymbolGroupGetReq{}
	s := service.LineSymbolGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineSymbolGroup

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取交易对组列表失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建交易对组列表
// @Summary 创建交易对组列表
// @Description 创建交易对组列表
// @Tags 交易对组列表
// @Accept application/json
// @Product application/json
// @Param data body dto.LineSymbolGroupInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-symbol-group [post]
// @Security Bearer
func (e LineSymbolGroup) Insert(c *gin.Context) {
	req := dto.LineSymbolGroupInsertReq{}
	s := service.LineSymbolGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建交易对组列表失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改交易对组列表
// @Summary 修改交易对组列表
// @Description 修改交易对组列表
// @Tags 交易对组列表
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineSymbolGroupUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-symbol-group/{id} [put]
// @Security Bearer
func (e LineSymbolGroup) Update(c *gin.Context) {
	req := dto.LineSymbolGroupUpdateReq{}
	s := service.LineSymbolGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改交易对组列表失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除交易对组列表
// @Summary 删除交易对组列表
// @Description 删除交易对组列表
// @Tags 交易对组列表
// @Param data body dto.LineSymbolGroupDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-symbol-group [delete]
// @Security Bearer
func (e LineSymbolGroup) Delete(c *gin.Context) {
	s := service.LineSymbolGroup{}
	req := dto.LineSymbolGroupDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除交易对组列表失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
